VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7260
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11100
   LinkTopic       =   "Form1"
   ScaleHeight     =   7260
   ScaleWidth      =   11100
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   2055
      Left            =   0
      ScaleHeight     =   1995
      ScaleWidth      =   2715
      TabIndex        =   3
      Top             =   480
      Width           =   2775
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   1440
      TabIndex        =   2
      Top             =   0
      Width           =   735
   End
   Begin VB.TextBox txtNumPoints 
      Height          =   285
      Left            =   720
      TabIndex        =   1
      Text            =   "7"
      Top             =   0
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "# Points"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_NumPoints As Integer

Private Declare Function Polygon Lib "gdi32" (ByVal hDC As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Sub cmdGo_Click()
Dim num_points As Integer

    On Error GoTo GoError
    
    num_points = CInt(txtNumPoints.Text)
    If num_points < 3 Then
        MsgBox "# Points must be at least 3", vbOKOnly Or vbExclamation, "Invalid # Points"
        Exit Sub
    Else
        m_NumPoints = num_points
        DrawStars
    End If
    Exit Sub

GoError:
    MsgBox Err.Description, vbOKOnly Or vbExclamation, "Error"
    Exit Sub
End Sub

Private Sub Form_Load()
    picCanvas.AutoRedraw = True
    picCanvas.ScaleMode = vbPixels
    m_NumPoints = 0
End Sub


Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - picCanvas.Top
    If hgt < 120 Then hgt = 120
    picCanvas.Move 0, picCanvas.Top, ScaleWidth, hgt
End Sub


' Draw the applicable stars.
Private Sub DrawStars()
Const RADIUS As Single = 40
Const PI As Double = 3.14159265

Dim skip, i, x, y As Integer
Dim pts() As POINTAPI
Dim theta As Double
Dim dtheta As Double

    If m_NumPoints < 3 Then Exit Sub

    ' Position the original points.
    ReDim pts(0 To m_NumPoints - 1)
    theta = -PI / 2
    dtheta = 2 * PI / m_NumPoints
    For i = 0 To m_NumPoints - 1
        pts(i).x = RADIUS * Cos(theta)
        pts(i).y = RADIUS * Sin(theta)
        theta = theta + dtheta
    Next i

    ' Draw stars.
    y = RADIUS + 5
    x = RADIUS + 5
    picCanvas.Cls
    For skip = 1 To m_NumPoints \ 2
        ' See if they are relatively prime.
        If GCD(skip, m_NumPoints) = 1 Then
            ' Draw the star.
            DrawStar picCanvas.hDC, x, y, pts, skip

            ' Draw a label.
            CenterTextHorizontally picCanvas, Format$(skip), x, y + RADIUS + 2

            x = x + 2 * RADIUS + 5
            If x + RADIUS >= picCanvas.ScaleWidth Then
                y = y + 2 * RADIUS + 15
                x = RADIUS + 5
            End If
        End If
    Next skip
End Sub
' Center the text horizontally at this Y position.
Private Sub CenterTextHorizontally(ByVal obj As Object, ByVal txt As String, ByVal x As Single, ByVal y As Single)
Dim wid As Single

    wid = obj.TextWidth(txt)
    obj.CurrentX = x - wid / 2
    obj.CurrentY = y
    obj.Print txt;
End Sub

' Draw a star centered at (x, y) using this skip value.
Private Sub DrawStar(ByVal pic_hdc As Long, ByVal x As Integer, ByVal y As Integer, orig_pts() As POINTAPI, ByVal skip As Integer)
Dim pts() As POINTAPI
Dim i As Integer

    ' Make a PointAPI array with the points in the proper order
    ' and translated so they are centered  at (x, y).
    ReDim pts(0 To m_NumPoints - 1)
    For i = 0 To m_NumPoints - 1
        pts(i).x = orig_pts((i * skip) Mod m_NumPoints).x + x
        pts(i).y = orig_pts((i * skip) Mod m_NumPoints).y + y
    Next i

    ' Draw the star.
    Polygon pic_hdc, pts(0), m_NumPoints
End Sub

' Return the greatest common divisor (GCD) of a and b.
Public Function GCD(ByVal a As Long, ByVal b As Long) As Long
Dim tmp As Long
Dim remainder As Long

    ' Make a >= b.
    a = Abs(a)
    b = Abs(b)
    If a < b Then
        tmp = a
        a = b
        b = tmp
    End If

    ' Pull out remainders.
    Do
        remainder = a Mod b
        If remainder = 0 Then Exit Do
        a = b
        b = remainder
    Loop

    GCD = b
End Function
